<?php
/**
 * oziz Theme Customizer
 *
 * @package oziz
 */
 
function headline_exts_multiple_category()
{
    $cats = array();
    $cats[0] = "All";
    foreach ( get_categories() as $categories => $category ) {
        $cats[$category->term_id] = $category->name . ' (' . $category->category_count . ')';
    }
    return $cats;
}
function headline_exts_get_pages()
{
    $pages  =  get_pages();
    $option_pages = array();
    $option_pages[0] = esc_html__('Select page', 'headline-ext');
    foreach( $pages as $p ){
        $option_pages[ $p->ID ] = $p->post_title;
    }
    return $option_pages;
}
function headline_exts_customizer_custom_panel($wp_customize)
{
    
    
    
    $priority = 1000;
    $wp_customize->add_panel(
        'headline_exts_panel_colors',
        array(
        'priority'        => $priority++,
        'title'           => esc_html__( 'Sections Pro Colors' , 'headline-ext' ),
        'description'     => ''
        )
    );
	$wp_customize->add_panel(
        'headline_exts_panel_fonts',
        array(
        'priority'        => $priority++,
        'title'           => esc_html__( 'Sections Pro Fonts' , 'headline-ext' ),
        'description'     => ''
        )
    );
	$wp_customize->add_panel(
        'headline_exts_panel_footer',
        array(
        'priority'        => $priority++,
        'title'           => esc_html__( 'Sections Pro Footer' , 'headline-ext' ),
        'description'     => ''
        )
    );
}
function headline_exts_data_default($key)
{
    $default['youtube_home_video_url'] = 'https://www.youtube.com/watch?v=PkZNo7MFNFg';
    $default['youtube_home_show'] = 'no';

    $default['about_setting_show'] = 'yes';
    
    if (isset($default[$key])) {
        return $default[$key];
    }
    return '';
}
function headline_exts_customizer_get_data_font_color()
{
	$headline_fonts = array(
		'' => esc_html__( 'Default' , 'headline-ext'),
		'Helvetica' => esc_html__( 'Helvetica' , 'headline-ext'),
		'Verdana' => esc_html__( 'Verdana' , 'headline-ext'),
		'Arial' => esc_html__( 'Arial' , 'headline-ext'),
		'Times' => esc_html__( 'Times' , 'headline-ext'),
		'Georgia' => esc_html__( 'Georgia' , 'headline-ext'),
		'Courier' => esc_html__( 'Courier' , 'headline-ext')
	);
	
	$headline_exts_data['setting_colors']['title'] = esc_html__('Setting Colors', 'headline-ext');
	$headline_exts_data['setting_colors']['panel'] = 'headline_exts_panel_colors';
	$headline_exts_data['setting_colors']['fields']['color_active'] = array(
	 'type'    => 'select',
	 'label'   => esc_html__( 'Color Active' , 'headline-ext'),
	 'choices' => array(
		 'yes' => esc_html__( 'Yes' , 'headline-ext'),
		 'no' => esc_html__( 'No', 'headline-ext'),    
	 ),
	 'default' => 'yes',
	);
	// Global Color
	$headline_exts_data['mycolors']['title'] = esc_html__('Global Colors', 'headline-ext');
	$headline_exts_data['mycolors']['panel'] = 'headline_exts_panel_colors';
	
	$headline_exts_data['mycolors']['fields']['global_color'] = array(
	 'type'    => 'color',
	 'label'   => esc_html__( 'Global Color' , 'headline-ext'),
	 'default' => '',
	);
    $headline_exts_data['mycolors']['fields']['link_color'] = array(
	 'type'    => 'color',
	 'label'   => esc_html__( 'Link Color' , 'headline-ext'),
	 'default' => '',
	);
	$headline_exts_data['mycolors']['fields']['link_hover_color'] = array(
	 'type'    => 'color',
	 'label'   => esc_html__( 'Link Hover Color' , 'headline-ext'),
	 'default' => '',
	);
	$headline_exts_data['mycolors']['fields']['sticky_bg_color'] = array(
	 'type'    => 'color',
	 'label'   => esc_html__( 'Sticky Background Color' , 'headline-ext'),
	 'default' => '',
	);
	$headline_exts_data['mycolors']['fields']['entry_span_color'] = array(
	 'type'    => 'color',
	 'label'   => esc_html__( 'Entry Span Color' , 'headline-ext'),
	 'default' => '',
	);
	$headline_exts_data['mycolors']['fields']['blockquote_color'] = array(
	 'type'    => 'color',
	 'label'   => esc_html__( 'BlockQuote Color' , 'headline-ext'),
	 'default' => '',
	);
	$headline_exts_data['mycolors']['fields']['blockquote_border_color'] = array(
	 'type'    => 'color',
	 'label'   => esc_html__( 'BlockQuote Border Color' , 'headline-ext'),
	 'default' => '',
	);
	$headline_exts_data['mycolors']['fields']['border_right_color'] = array(
	 'type'    => 'color',
	 'label'   => esc_html__( 'Border Right Color' , 'headline-ext'),
	 'default' => '',
	);
	$headline_exts_data['mycolors']['fields']['border_bottom_color'] = array(
	 'type'    => 'color',
	 'label'   => esc_html__( 'Border Bottom Color' , 'headline-ext'),
	 'default' => '',
	);
	$headline_exts_data['mycolors']['fields']['sticky_bg_color'] = array(
	 'type'    => 'color',
	 'label'   => esc_html__( 'Sticky BG Color' , 'headline-ext'),
	 'default' => '',
	);
	$headline_exts_data['mycolors']['fields']['widgetright_title_color'] = array(
	 'type'    => 'color',
	 'label'   => esc_html__( 'Widget Title Color' , 'headline-ext'),
	 'default' => '',
	);
	$headline_exts_data['mycolors']['fields']['widgetright_link_color'] = array(
	 'type'    => 'color',
	 'label'   => esc_html__( 'Widget Link Color' , 'headline-ext'),
	 'default' => '',
	);
	$headline_exts_data['mycolors']['fields']['widgetright_link_color_hover'] = array(
	 'type'    => 'color',
	 'label'   => esc_html__( 'Widget Link Color Hover' , 'headline-ext'),
	 'default' => '',
	);
	// HEader Color
	$headline_exts_data['header_colors']['title'] = esc_html__('Header Colors', 'headline-ext');
	$headline_exts_data['header_colors']['panel'] = 'headline_exts_panel_colors';
	$headline_exts_data['header_colors']['fields']['site_title_color'] = array(
	 'type'    => 'color',
	 'label'   => esc_html__( 'Site Title Color' , 'headline-ext'),
	 'default' => '',
	);
	$headline_exts_data['header_colors']['fields']['site_title_color_hover'] = array(
	 'type'    => 'color',
	 'label'   => esc_html__( 'Site Title Color Hover' , 'headline-ext'),
	 'default' => '',
	);
	
    
	// Menu
	
	$headline_exts_data['menu_colors']['title'] = esc_html__('Menu Colors', 'headline-ext');
	$headline_exts_data['menu_colors']['panel'] = 'headline_exts_panel_colors';
	$headline_exts_data['menu_colors']['fields']['menu_bg_color'] = array(
	 'type'    => 'color',
	 'label'   => esc_html__( 'Menu Background Color' , 'headline-ext'),
	 'default' => '',
	);
	$headline_exts_data['menu_colors']['fields']['menu_link1_color'] = array(
	 'type'    => 'color',
	 'label'   => esc_html__( 'Menu Link 1 Color' , 'headline-ext'),
	 'default' => '',
	);
	$headline_exts_data['menu_colors']['fields']['menu_link1_color_selected'] = array(
	 'type'    => 'color',
	 'label'   => esc_html__( 'Menu Link 1 Color Selected' , 'headline-ext'),
	 'default' => '',
	);
	$headline_exts_data['menu_colors']['fields']['menu_link1_bg_color_selected'] = array(
	 'type'    => 'color',
	 'label'   => esc_html__( 'Menu Link 1 BG Color Selected' , 'headline-ext'),
	 'default' => '',
	);
	// Menu Second
	$headline_exts_data['menu_colors']['fields']['menu_bg2_color'] = array(
	 'type'    => 'color',
	 'label'   => esc_html__( 'Menu Background Color 2' , 'headline-ext'),
	 'default' => '',
	);
	$headline_exts_data['menu_colors']['fields']['menu_link2_color'] = array(
	 'type'    => 'color',
	 'label'   => esc_html__( 'Menu Link 2 Color' , 'headline-ext'),
	 'default' => '',
	);
	$headline_exts_data['menu_colors']['fields']['menu_link2_color_hover'] = array(
	 'type'    => 'color',
	 'label'   => esc_html__( 'Menu Link 2 Color Hover' , 'headline-ext'),
	 'default' => '',
	);
	
	$headline_exts_data['menu_colors']['fields']['menu_link2_border_color'] = array(
	 'type'    => 'color',
	 'label'   => esc_html__( 'Menu Link 2 Border Color' , 'headline-ext'),
	 'default' => '',
	);
	$headline_exts_data['menu_colors']['fields']['menu_link2_color_selected'] = array(
	 'type'    => 'color',
	 'label'   => esc_html__( 'Menu Link 2 Color Selected' , 'headline-ext'),
	 'default' => '',
	);
	// Responsive Menu
	$headline_exts_data['menuresponsive_colors']['title'] = esc_html__('Responsive Menu Colors', 'headline-ext');
	$headline_exts_data['menuresponsive_colors']['panel'] = 'headline_exts_panel_colors';
	$headline_exts_data['menuresponsive_colors']['fields']['menuresponsive_bg_color'] = array(
	 'type'    => 'color',
	 'label'   => esc_html__( 'Menu Responsive Background Color' , 'headline-ext'),
	 'default' => '',
	);
	$headline_exts_data['menuresponsive_colors']['fields']['menuresponsive_link_bg_color'] = array(
	 'type'    => 'color',
	 'label'   => esc_html__( 'Menu Responsive Background UL' , 'headline-ext'),
	 'default' => '',
	);
	$headline_exts_data['menuresponsive_colors']['fields']['menuresponsive_link_color'] = array(
	 'type'    => 'color',
	 'label'   => esc_html__( 'Menu Responsive Link' , 'headline-ext'),
	 'default' => '',
	);
	$headline_exts_data['menuresponsive_colors']['fields']['menuresponsive_link_color_hover'] = array(
	 'type'    => 'color',
	 'label'   => esc_html__( 'Menu Responsive Link Hover' , 'headline-ext'),
	 'default' => '',
	);
	$headline_exts_data['menuresponsive_colors']['fields']['menuresponsive_link_border_color'] = array(
	 'type'    => 'color',
	 'label'   => esc_html__( 'Menu Responsive Link Border Color' , 'headline-ext'),
	 'default' => '',
	);
	// Fonts
	$headline_exts_data['setting_fonts']['title'] = esc_html__('Setting Fonts', 'headline-ext');
	$headline_exts_data['setting_fonts']['panel'] = 'headline_exts_panel_fonts';
	$headline_exts_data['setting_fonts']['fields']['font_active'] = array(
	 'type'    => 'select',
	 'label'   => esc_html__( 'Font Active' , 'headline-ext'),
	 'choices' => array(
		 'yes' => esc_html__( 'Yes' , 'headline-ext'),
		 'no' => esc_html__( 'No', 'headline-ext'),    
	 ),
	 'default' => 'yes',
	);
	// Global Fonts
	$headline_exts_data['global_fonts']['title'] = esc_html__('Global Fonts', 'headline-ext');
	$headline_exts_data['global_fonts']['panel'] = 'headline_exts_panel_fonts';
	$headline_exts_data['global_fonts']['fields']['body_font_family'] = array(
	 'type'    => 'select',
	 'label'   => esc_html__( 'Body Font Family' , 'headline-ext'),
	 'choices' => $headline_fonts,
	 'default' => '',
	);
	$headline_exts_data['global_fonts']['fields']['body_font_size'] = array(
	 'type'    => 'text',
	 'label'   => esc_html__( 'Body Font Size' , 'headline-ext'),
	 'default' => '',
	);
	
	// Heading
		
	$headline_exts_data['header_fonts']['title'] = esc_html__('Header Fonts', 'headline-ext');
	$headline_exts_data['header_fonts']['panel'] = 'headline_exts_panel_fonts';
	$headline_exts_data['header_fonts']['fields']['site_title_font_size'] = array(
	 'type'    => 'text',
	 'label'   => esc_html__( 'Site Title Font Size' , 'headline-ext'),
	 'default' => '',
	);
	$headline_exts_data['header_fonts']['fields']['site_description_font_size'] = array(
	 'type'    => 'text',
	 'label'   => esc_html__( 'Site Title Font Size' , 'headline-ext'),
	 'default' => '',
	);
	// Heading
		
	$headline_exts_data['heading_fonts']['title'] = esc_html__('Heading Fonts', 'headline-ext');
	$headline_exts_data['heading_fonts']['panel'] = 'headline_exts_panel_fonts';
	$headline_exts_data['heading_fonts']['fields']['heading_font_family'] = array(
	 'type'    => 'select',
	 'label'   => esc_html__( 'Body Font Family' , 'headline-ext'),
	 'choices' => $headline_fonts,
	 'default' => '',
	);
	$headline_exts_data['heading_fonts']['fields']['h1_font_size'] = array(
	 'type'    => 'text',
	 'label'   => esc_html__( 'H1 Font Size' , 'headline-ext'),
	 'default' => '',
	);
	$headline_exts_data['heading_fonts']['panel'] = 'headline_exts_panel_fonts';
	$headline_exts_data['heading_fonts']['fields']['h2_font_size'] = array(
	 'type'    => 'text',
	 'label'   => esc_html__( 'H2 Font Size' , 'headline-ext'),
	 'default' => '',
	);
	$headline_exts_data['heading_fonts']['panel'] = 'headline_exts_panel_fonts';
	$headline_exts_data['heading_fonts']['fields']['h3_font_size'] = array(
	 'type'    => 'text',
	 'label'   => esc_html__( 'H3 Font Size' , 'headline-ext'),
	 'default' => '',
	);
	$headline_exts_data['heading_fonts']['panel'] = 'headline_exts_panel_fonts';
	$headline_exts_data['heading_fonts']['fields']['h4_font_size'] = array(
	 'type'    => 'text',
	 'label'   => esc_html__( 'H4 Font Size' , 'headline-ext'),
	 'default' => '',
	);
	$headline_exts_data['heading_fonts']['panel'] = 'headline_exts_panel_fonts';
	$headline_exts_data['heading_fonts']['fields']['h5_font_size'] = array(
	 'type'    => 'text',
	 'label'   => esc_html__( 'H5 Font Size' , 'headline-ext'),
	 'default' => '',
	);
	$headline_exts_data['heading_fonts']['panel'] = 'headline_exts_panel_fonts';
	$headline_exts_data['heading_fonts']['fields']['h6_font_size'] = array(
	 'type'    => 'text',
	 'label'   => esc_html__( 'H6 Font Size' , 'headline-ext'),
	 'default' => '',
	);
	// Single Fonts
	$headline_exts_data['single_fonts']['title'] = esc_html__('Post Fonts', 'headline-ext');
	$headline_exts_data['single_fonts']['panel'] = 'headline_exts_panel_fonts';
	$headline_exts_data['single_fonts']['fields']['h1_entry_title_font_size'] = array(
	 'type'    => 'text',
	 'label'   => esc_html__( 'H1 entry_title Font Size' , 'headline-ext'),
	 'default' => '',
	);
	$headline_exts_data['single_fonts']['fields']['h2_entry_title_font_size'] = array(
	 'type'    => 'text',
	 'label'   => esc_html__( 'H2 entry_title Font Size' , 'headline-ext'),
	 'default' => '',
	);
	// FONTS ENDS

    return $headline_exts_data;
}
function headline_exts_customizer_get_data_footer(){
	// Footer
	$headline_exts_data['footer']['title'] = esc_html__('Footer', 'headline-ext');
	$headline_exts_data['footer']['panel'] = 'headline_exts_panel_footer';
	$headline_exts_data['footer']['fields']['footer_copyright_show'] = array(
	 'type'    => 'select',
	 'label'   => esc_html__( 'Show Footer Copyright' , 'headline-ext'),
	 'choices' => array(
		 'yes' => esc_html__( 'Yes' , 'headline-ext'),
		 'no' => esc_html__( 'No', 'headline-ext'),    
	 ),
	 'default' => 'yes',
	);
	$headline_exts_data['footer']['fields']['footer_copyright'] = array(
	 'type'    => 'textarea',
	 'label'   => esc_html__( 'Footer Copyright' , 'headline-ext'),
	 'default' => '',
	);
	
    return $headline_exts_data;
}
function headline_exts_customizer_custom_fields_set($wp_customize,$aData,$section_priority = 160 ){
	foreach ( $aData as $section_name => $section_data ) {
        /**
         * Section
         */
        $default_sections = array( 'title_tagline', 'colors', 'header_image', 'background_image', 'static_front_page', 'featured_content' );
        if (! in_array($section_name, $default_sections, true) ) {
            $defaults = array(
            'priority' => $section_priority++,
            );

            $section_args = wp_parse_args($section_data, $defaults);
            $wp_customize->add_section($section_name, $section_args);
        }

        $control_priority = 1;
        foreach ( (array) $section_data['fields'] as $field_name => $field_data ) {
            /**
             * Setting
             */
            if ('custom' === $field_data['type'] ) {
                $wp_customize->add_setting(
                    $field_name,
                    array(
                    'sanitize_callback' => '__return_false',
                    )
                );
            } else {
                $wp_customize->add_setting(
                    $field_name,
                    array(
                    'default'           => isset($field_data['default']) ? $field_data['default'] : '',
                    'sanitize_callback' => isset($field_data['sanitize_callback']) ? $field_data['sanitize_callback'] : headline_exts_get_sanitize_callback($field_data['type']),
                    'transport' => isset($field_data['transport']) ? $field_data['transport'] : 'refresh'
                    )
                );
            }

            /**
             * Control
             */
            $defaults = array(
            'priority' => $control_priority++,
            'section'  => $section_name,
            );

            $control_args = wp_parse_args($field_data, $defaults);
            switch ( $control_args['type'] ) {
            case 'image':
                $wp_customize->add_control(new WP_Customize_Image_Control($wp_customize, $field_name, $control_args));
                break;
                
            case 'image-crop':
                unset($control_args['type']);
                $wp_customize->add_control(new WP_Customize_Cropped_Image_Control($wp_customize, $field_name, $control_args));
                break;
            case 'upload':
                unset($control_args['type']);
                $wp_customize->add_control(new WP_Customize_Upload_Control($wp_customize, $field_name, $control_args));
                break;
                    
            case 'color':
                $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize, $field_name, $control_args));
                break;
                
            case 'datetime':
                //print_r($control_args); die();
                unset($control_args['type']);
                $wp_customize->add_control(new WP_Customize_Date_Time_Control($wp_customize, $field_name, $control_args));
                break;
            case 'multiple-select':
                      $wp_customize->add_control(new headline_exts_Multiple_Select_Control($wp_customize, $field_name, $control_args));
                break;
            case 'radio-image':
                      unset($control_args['type']);
                      $wp_customize->add_control(new headline_exts_Radio_Image_Control($wp_customize, $field_name, $control_args));
                break;
            case 'custom':    
                      unset($control_args['type']);
                      $wp_customize->add_control(new headline_exts_Custom_Control($wp_customize, $field_name, $control_args));
                break;
            case 'color-alpha':
                      unset($control_args['type']);
                      $wp_customize->add_control(new headline_exts_Alpha_Color_Control($wp_customize, $field_name, $control_args));
                break;
            case 'dropdown-category':
                      unset($control_args['type']);
                      $wp_customize->add_control(new headline_exts_Category_Control($wp_customize, $field_name, $control_args));
                break;    
            case 'editor':
                      unset($control_args['type']);
                      $wp_customize->add_control(new headline_exts_Editor_Custom_Control($wp_customize, $field_name, $control_args));
                break;
            case 'repeatable':
                      unset($control_args['type']);
                      $wp_customize->add_control(new headline_exts_Customize_Repeatable_Control($wp_customize, $field_name, $control_args));
                break;
                
            default:
                      $wp_customize->add_control($field_name, $control_args);
                break;
            }
        }
    }	
}

function headline_exts_customizer_custom_fields( $wp_customize,$section_priority = 160 )
{
	headline_exts_customizer_custom_fields_set($wp_customize,headline_exts_customizer_get_data_font_color(),160 );
	headline_exts_customizer_custom_fields_set($wp_customize,headline_exts_customizer_get_data_footer(),200 );
}


function headline_exts_get_sanitize_callback( $type )
{
    switch ( $type ) {
    case 'text':
        return 'sanitize_text_field';
    case 'textarea':
        return 'sanitize_textarea_field';
    case 'color':
        return 'sanitize_hex_color';
    case 'checkbox':
        return 'headline_exts_sanitize_checkbox';
        
    case 'radio':
    case 'radio-image':
    case 'select':
        return 'headline_exts_sanitize_select';
    case 'multiple-select':
        return 'headline_exts_sanitize_multiple';
    case 'editor':
        return 'wp_kses_post';
    case 'repeatable':
        return 'headline_exts_sanitize_repeatable_data_field';
    default:
        return 'sanitize_text_field';
    }
}