<?php
/*
Plugin Name: Headline Pro Extensions 
Plugin URI: http://wpamanuke.com/downloads/headline-pro-extension/
Description: Headline coloring and font options
Version: 1.0.4
Author: WPAmaNuke
Author URI: http://www.wpamanuke.com/
Text Domain: headline-ext
Domain Path: /languages
License: GPLv2
License URI: https://www.gnu.org/licenses/gpl-2.0.html
*/

if( ! defined( 'HEADLINE_EXTS_URL' ) ) {
	define( 'HEADLINE_EXTS_URL', plugin_dir_url( __FILE__ ) ); }

if( ! defined( 'BUSINESSX_EXTS_PATH' ) ) {
	define( 'HEADLINE_EXTS_PATH', plugin_dir_path( __FILE__ ) ); }
	
	
/* Theme names */
if( ! function_exists( 'headline_exts_theme' ) ) {
	/**
	 * Get current theme name
	 *
	 * @since  1.0.0
	 * @param  boolean $parent Return child name if false
	 * @return string          Current theme name
	 */
	function headline_exts_theme( $parent = false ) {
		$theme = wp_get_theme();
		if( ! $parent ) {
			return $theme->name;
		} else {
			return $theme->parent_theme;
		}
	}
}



/* Required Headline or a child theme of it to be the current theme */
if ( ( 'Headline' == headline_exts_theme() ) || ( 'Headline' == headline_exts_theme( true ) ) ) {
	require_once ( dirname( __FILE__ ) . '/customizer/customizer.php' );
	require_once ( dirname( __FILE__ ) . '/inc/template-color.php' );
}